Subject: Re: [ROUTE] PMTU only works on half the time

From: "David S. Miller" <[email-masked]>
Date: Mon, 1 Dec 2003 15:22:15 -0800

On Mon, 1 Dec 2003 14:21:31 -0800
"David S. Miller" <[email-masked]> wrote:

> Let me think about this some more, maybe you're right and the
> error exists in both of these places.

Ok, I did my thinking :)

rt->rt_src is special.  It is the source address we have selected
to use with this route.  All output packets using this route must
use rt->rt_src as iph->saddr.

So, in effect, when we say "if (rt->rt_src == iph->saddr)" we
are asking the question "did we make this packet?"  I think this
is why Alexey coded the test in this way.

You are speaking of a case of zero source addresses.  When would
we output such an iph->saddr, by way of a route?  Right now this
is the only part I'm not seeing.

I want to be careful in changing this code, as loosening the key check
opens the possibility of new kinds of PMTU lowering attacks.